﻿Option Strict On
Option Explicit On
Imports System.Text
Imports System.Runtime.InteropServices

Module Module1
   Sub Main()
      Dim section, key As String
      Dim filename As String = "..\..\data.ini"

      Dim data As New List(Of String())
      key = String.Format("data{0}", 0)
      section = String.Format("Section{0}", 0)
      data.Add(DllHelpers.ReadSections(filename, section, key) _
                         .Split(New String() {" "},
                         StringSplitOptions.RemoveEmptyEntries))

      For i As Int32 = 0 To 1
         key = String.Format("data{0}", i)
         section = String.Format("Section{0}", i)
         data.Add(DllHelpers.ReadSections(filename, section, key) _
                            .Split(New String() {" "},
                            StringSplitOptions.RemoveEmptyEntries))
      Next

      Stop
   End Sub
End Module

Public Class DllHelpers
   <DllImport("kernel32.dll")>
   Public Shared Function GetLastError() As UInteger
   End Function
   <DllImport("kernel32.dll", SetLastError:=True)>
   Public Shared Function GetPrivateProfileString(ByVal lpAppName As String,
                                                  ByVal lpKeyName As String,
                                                  ByVal lpDefault As String,
                                                  ByVal lpReturnedString As StringBuilder,
                                                  ByVal nSize As Int32,
                                                  ByVal lpFileName As String) As Int32
   End Function
   Public Shared Function ReadSections(filename As String,
                               section As String,
                               key As String) As String
      Dim sb = New StringBuilder(1024)
      Dim length As Integer = DllHelpers.GetPrivateProfileString(section,
                                                                 key,
                                                                 String.Empty,
                                                                 sb,
                                                                 sb.Capacity,
                                                                 filename)
      If length = 0 Then
         Console.WriteLine(DllHelpers.GetLastError.ToString)
      End If
      Return sb.ToString
   End Function
End Class